;----------------------------------------------------------------------------
;File name:	_SKELTON.S			Revision date:	1998.06.20
;Revised by:	Ulf Ronald Andersson		Revision start:	1998.06.20
;----------------------------------------------------------------------------
; QED-ASMPAR 4 0006  $DSDR:Z:125,M:4
;Desert	Drain V1.52   680x0er Disassembler  20.06.1998 16:00:12
;DATEI:	24BIT.PRG   706	Bytes
;TEXT:	  302	$0012E
;DATA:	  360	$00168
;----------------------------------------------------------------------------
	SECTION	TEXT
;----------------------------------------------------------------------------
	movea.l	4(SP),A6
	clr.l	-(SP)
	move.w	#$20,-(SP)
	trap	#1			;Super
	move.l	D0,D7
	addq.w	#6,SP
	movea.l	$5A0.w,A0		;_cookies
T_14:
	tst.l	(A0)
	beq	CPU_is_not_68030
	cmpi.l	#'_CPU',(A0)+
	beq.s	have_CPU
	addq.w	#4,A0
	bra.s	T_14
;
have_CPU:
	cmpi.w	#30,(A0)
	bne	CPU_is_not_68030
	sf	D6			;clr flag (absence of ALT RAM)
	cmpi.l	#$1357BD13,$5A8.w	;ramvalid
	bne.s	T_60
	move.l	$5A4.w,D0		;ramtop
	cmp.l	#$1000000,D0		;ramtop > 16M (ALT RAM base)
	ble.s	T_60			;else no ALT RAM is defined
	sub.l	#$1000000,D0		;calculate ALT RAM size
;
	move.w	#1,-(SP)		;push flag to demand ALT RAM
	move.l	D0,-(SP)		;push flag to demand all of it
	move.w	#$44,-(SP)		;push Mxalloc function code
	trap	#1			;call GEMDOS
	addq.w	#8,SP			;clean stack
;
	tst.l	D0			;test result
	beq.s	ALT_RAM_in_use
	st	D6			;set flag (ALT RAM blocked)
T_60:
	movec.l	CACR,D0
	or.w	#$808,D0
	and.w	#$FEFE,D0
	movec.l	D0,CACR
	pmove	init_NULL,tc
	pmove	init_NULL,tt0
	pmove	init_NULL,tt1
	bsr.s	T_108
;
	move.l	D7,-(SP)
	move.w	#$20,-(SP)
	trap	#1			;Super
	pea	now_install_s
	move.w	#9,-(SP)
	trap	#1			;Cconws
	tst.b	D6
	beq.s	T_AE
	clr.w	-(SP)
	clr.l	-(SP)
	move.w	#$31,-(SP)
	trap	#1			;Ptermres
	illegal
;----------------------------------------------------------------------------
T_AE:
	clr.w	-(SP)
	trap	#1			;Pterm0
;----------------------------------------------------------------------------
	illegal
;----------------------------------------------------------------------------
ALT_RAM_in_use:
	pea	ALT_RAM_used_s
	bra.s	no_install
;----------------------------------------------------------------------------
CPU_is_not_68030:
	pea	CPU_no_68030_s
no_install:
	move.w	#9,-(SP)
	trap	#1			;Cconws
	move.l	#no_install_s,2(SP)
	move.w	#9,(SP)
	trap	#1			;Cconws
	bsr.s	get_keypress
	move.w	#1,-(SP)
	move.w	#$4C,-(SP)
	trap	#1			;Pterm
;----------------------------------------------------------------------------
	illegal
;----------------------------------------------------------------------------
get_keypress:
	pea	key_to_exit_s
	move.w	#9,-(SP)
	trap	#1			;Cconws
	move.w	#8,(SP)
	trap	#1			;Cnecin
	move.l	#crlf_s,2(SP)
	move.w	#9,(SP)
	trap	#1			;Cconws
	addq.w	#6,SP
	rts
;----------------------------------------------------------------------------
T_108:
	lea	$700.w,A2
	move.l	a2,a0
	lea	TR_00,A1
	moveq	#(TR_end-TR_00)/4-1,D0
T_116:
	move.l	(A1)+,(A0)+
	dbra	D0,T_116
	add.l	a2,TR_00_td-TR_00(a2)
	add.l	a2,TR_10_td-TR_10(a2)
	add.l	a2,TR_20_td-TR_20(a2)
	pmove	CRP_fixval,crp
	pmove	TC_fixval,tc
	rts
;----------------------------------------------------------------------------
	SECTION	DATA
;----------------------------------------------------------------------------
CPU_no_68030_s:	dc.b	'The CPU is not a 68030 !',$D,$A,$0
now_install_s:	dc.b	'24-bit addressing now in effect (rev 2).',$D,$A,$0
ALT_RAM_used:	dc.b	'Your ALT RAM is not empty!',$D,$A,$0
no_install_s:	dc.b	'24-bit addressing not installed.',$D,$A,$0
key_to_exit_s:	dc.b	'Press any key to exit: ',$0
crlf_s:		dc.b	$D,$A,$0,$0
;
init_NULL:	dc.b	$00000000	;zero init value for tc,tt0,tt1
;

TR_00:		dc.l	$00000001,$00400001,$00800001
TR_00_td:	dc.l					$00000012
TR_10:		dc.l	$00C00001,$00D00001,$00E00001
TR_10_td:	dc.l					$00000022
TR_20:		dc.l	$00F00001,$00F40001,$00F80001
TR_20_td:	dc.l					$00000032
TR_30:		dc.l	$00FC0001,$00FD0001,$00FE0001,$FFFF0041
TR_end:
;
CRP_fixval:	dc.l	$80000002,$00000700	;final value for crp
TC_fixval:		dc.l	$80882222		;final value for tc
;----------------------------------------------------------------------------
	END
;----------------------------------------------------------------------------
